/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2003 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 2.02 of the PHP license,      |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/2_02.txt.                                 |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Author:                                                              |
  +----------------------------------------------------------------------+

  $Id: header,v 1.10.8.1 2003/07/14 15:59:18 sniper Exp $ 
  
  Todo:
  
  - creds are not freed!
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#include "php_ini.h"
#include "ext/standard/info.h"
#include "php_btnsms.h"
#include <btnsms.h>

/* If you declare any globals in php_btnsms.h uncomment this:
ZEND_DECLARE_MODULE_GLOBALS(btnsms)
*/

/* True global resources - no need for thread safety here */
static int le_btnsms;
static int le_btnresult;
static int le_btncreds;

#define le_btnsms_name "btnsms"
#define le_btnresult_name "btnresult"
#define le_btncreds_name "btncreds"

/* {{{ btnsms_functions[]
 *
 * Every user visible function must have an entry in btnsms_functions[].
 */
function_entry btnsms_functions[] = {
	PHP_FE(btnsms_sendsimple,	NULL)		/* For testing, remove later. */
	PHP_FE(btnsms_new,		NULL)
	PHP_FE(btnsms_setcreds,		NULL)
	PHP_FE(btnsms_adddestination,	NULL)
	PHP_FE(btnsms_settext,		NULL)
	PHP_FE(btnsms_settype,		NULL)
	PHP_FE(btnsms_settarif,		NULL)
	PHP_FE(btnsms_setdelivery,	NULL)
	PHP_FE(btnsms_setoriginator,	NULL)
	PHP_FE(btnsms_setgreetsubst,	NULL)
	PHP_FE(btnsms_send,		NULL)
	PHP_FE(btnsms_geterrorcode,	NULL)
	PHP_FE(btnsms_geterrormsg,	NULL)
	PHP_FE(btnsms_getaccountbalance,NULL)
	PHP_FE(btnsms_getstatusreportid,NULL)
	PHP_FE(btnsms_getdestinationerrors,NULL)
	PHP_FE(btnsms_getuserstatus,NULL)
	{NULL, NULL, NULL}	/* Must be the last line in btnsms_functions[] */
};
/* }}} */

/* {{{ btnsms_module_entry
 */
zend_module_entry btnsms_module_entry = {
#if ZEND_MODULE_API_NO >= 20010901
	STANDARD_MODULE_HEADER,
#endif
	"btnsms",
	btnsms_functions,
	PHP_MINIT(btnsms),
	PHP_MSHUTDOWN(btnsms),
	PHP_RINIT(btnsms),		/* Replace with NULL if there's nothing to do at request start */
	PHP_RSHUTDOWN(btnsms),	/* Replace with NULL if there's nothing to do at request end */
	PHP_MINFO(btnsms),
#if ZEND_MODULE_API_NO >= 20010901
	"0.1", /* Replace with version number for your extension */
#endif
	STANDARD_MODULE_PROPERTIES
};
/* }}} */

#ifdef COMPILE_DL_BTNSMS
ZEND_GET_MODULE(btnsms)
#endif

/* {{{ PHP_INI
 */
/* Remove comments and fill if you need to have entries in php.ini
PHP_INI_BEGIN()
    STD_PHP_INI_ENTRY("btnsms.global_value",      "42", PHP_INI_ALL, OnUpdateInt, global_value, zend_btnsms_globals, btnsms_globals)
    STD_PHP_INI_ENTRY("btnsms.global_string", "foobar", PHP_INI_ALL, OnUpdateString, global_string, zend_btnsms_globals, btnsms_globals)
PHP_INI_END()
*/
/* }}} */

/* {{{ php_btnsms_init_globals
 */
/* Uncomment this function if you have INI entries
static void php_btnsms_init_globals(zend_btnsms_globals *btnsms_globals)
{
	btnsms_globals->global_value = 0;
	btnsms_globals->global_string = NULL;
}
*/
/* }}} */

void btnsms_destruction_handler(zend_rsrc_list_entry *rsrc TSRMLS_DC) {
    ptrBtnSms sms = (ptrBtnSms) rsrc->ptr;
    btnCredsFree(sms->credentials);
    btnSmsFree(sms);
}

void btnresult_destruction_handler(zend_rsrc_list_entry *rsrc TSRMLS_DC) {
    ptrBtnResult result = (ptrBtnResult) rsrc->ptr;
    btnResultFree(result);
}

void btncreds_destruction_handler(zend_rsrc_list_entry *rsrc TSRMLS_DC) {
    ptrBtnCreds creds = (ptrBtnCreds) rsrc->ptr;
    btnCredsFree(creds);
}

/* {{{ PHP_MINIT_FUNCTION
 */
PHP_MINIT_FUNCTION(btnsms)
{
	le_btnsms = zend_register_list_destructors_ex(btnsms_destruction_handler,NULL,le_btnsms_name,module_number);
	le_btnresult = zend_register_list_destructors_ex(btnresult_destruction_handler,NULL,le_btnresult_name,module_number);
	le_btncreds = zend_register_list_destructors_ex(btncreds_destruction_handler,NULL,le_btncreds_name,module_number);

	REGISTER_LONG_CONSTANT("BTNSMS_TARIF_ECO", BTN_TARIF_ECO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_TARIF_STANDARD", BTN_TARIF_STANDARD, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_TARIF_PREMIUM", BTN_TARIF_PREMIUM, CONST_CS | CONST_PERSISTENT);

	REGISTER_LONG_CONSTANT("BTNSMS_TYPE_NORMAL", BTN_TYPE_NORMAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_TYPE_FLASH", BTN_TYPE_FLASH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_TYPE_LONG", BTN_TYPE_LONG, CONST_CS | CONST_PERSISTENT);

	REGISTER_LONG_CONSTANT("BTNSMS_TYPE_NOKIA_OPERATOR_LOGO", BTN_TYPE_NOKIA_OPERATOR_LOGO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_TYPE_NOKIA_PICTURE_MESSAGE", BTN_TYPE_NOKIA_PICTURE_MESSAGE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_TYPE_NOKIA_GROUP_LOGO", BTN_TYPE_NOKIA_GROUP_LOGO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_TYPE_NOKIA_RINGTONE", BTN_TYPE_NOKIA_RINGTONE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_TYPE_SIEMENS_DATA", BTN_TYPE_SIEMENS_DATA, CONST_CS | CONST_PERSISTENT);

	REGISTER_LONG_CONSTANT("BTNSMS_ERRORCODE_SUCCESS", BTN_ERROR_SUCCESS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_ERRORCODE_NOCREDIT", BTN_ERROR_NOCREDIT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_ERRORCODE_WRONCREDS", BTN_ERROR_WRONGCREDS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_ERRORCODE_INTERNAL", BTN_ERROR_INTERNAL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_ERRORCODE_CLOSEDACCOUNT", BTN_ERROR_CLOSEDACCOUNT, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_ERRORCODE_WRONGIP", BTN_ERROR_WRONGIP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_ERRORCODE_WRONGSMS", BTN_ERROR_WRONGSMS, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_ERRORCODE_WRONGXML", BTN_ERROR_WRONGXML, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_ERRORCODE_PARTIAL_SUCCESS", BTN_ERROR_PARTIAL_SUCCESS, CONST_CS | CONST_PERSISTENT);

	REGISTER_LONG_CONSTANT("BTNSMS_ERRORCODE_FLAG_HTTP", BTN_ERROR_FLAG_HTTP, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_ERRORCODE_FLAG_CURL", BTN_ERROR_FLAG_CURL, CONST_CS | CONST_PERSISTENT);

	REGISTER_LONG_CONSTANT("BTNSMS_USERTYPE_FREE", BTN_USERTYPE_FREE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_USERTYPE_PREPAID", BTN_USERTYPE_PREPAID, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("BTNSMS_USERTYPE_BILLED", BTN_USERTYPE_BILLED, CONST_CS | CONST_PERSISTENT);
	
	/* If you have INI entries, uncomment these lines 
	ZEND_INIT_MODULE_GLOBALS(btnsms, php_btnsms_init_globals, NULL);
	REGISTER_INI_ENTRIES();
	*/
	return SUCCESS;
}
/* }}} */

/* {{{ PHP_MSHUTDOWN_FUNCTION
 */
PHP_MSHUTDOWN_FUNCTION(btnsms)
{
	/* uncomment this line if you have INI entries
	UNREGISTER_INI_ENTRIES();
	*/
	return SUCCESS;
}
/* }}} */

/* Remove if there's nothing to do at request start */
/* {{{ PHP_RINIT_FUNCTION
 */
PHP_RINIT_FUNCTION(btnsms)
{
	return SUCCESS;
}
/* }}} */

/* Remove if there's nothing to do at request end */
/* {{{ PHP_RSHUTDOWN_FUNCTION
 */
PHP_RSHUTDOWN_FUNCTION(btnsms)
{
	return SUCCESS;
}
/* }}} */

/* {{{ PHP_MINFO_FUNCTION
 */
PHP_MINFO_FUNCTION(btnsms)
{
	php_info_print_table_start();
	php_info_print_table_header(2, "btnsms support", "enabled");
	php_info_print_table_end();

	/* Remove comments if you have entries in php.ini
	DISPLAY_INI_ENTRIES();
	*/
}
/* }}} */


/* Remove the following function when you have succesfully modified config.m4
   so that your module can be compiled into PHP, it exists only for testing
   purposes. */

/* Every user-visible function in PHP should document itself in the source */
/* {{{ proto string confirm_btnsms_compiled(string arg)
   Return a string to confirm that the module is compiled in */
PHP_FUNCTION(btnsms_sendsimple)
{
	char *uid;
	char *pwd;
	char *dst;
	char *text;
	
	int uid_len, pwd_len, dst_len, text_len;
	int result;

	if (ZEND_NUM_ARGS() != 4) WRONG_PARAM_COUNT;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "ssss", &uid, &uid_len, &pwd, &pwd_len, &dst, &dst_len, &text, &text_len) == FAILURE) {
		return;
	}
    
	result = btnSmsSendSimple(uid,pwd,dst,text);
	
	RETURN_LONG(result);
}
/* }}} */

PHP_FUNCTION(btnsms_new)
{
	ptrBtnSms sms;
	zval *sms_resource;
	int sms_id;
	
	sms = btnSmsNew();

	MAKE_STD_ZVAL(sms_resource);
	
	sms_id = ZEND_REGISTER_RESOURCE(sms_resource, sms, le_btnsms);	

	RETURN_RESOURCE(sms_id);
}

PHP_FUNCTION(btnsms_setcreds) {
	ptrBtnSms sms;
	ptrBtnCreds creds;

	zval *sms_resource;
	char *userid;
	char *password;
	char *customnumber;
	int userid_len, password_len, customnumber_len;
	
	customnumber = 0;
	customnumber_len = 0;
	
	if (ZEND_NUM_ARGS() < 3 || ZEND_NUM_ARGS() > 4) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "rss|s", &sms_resource, &userid, &userid_len, &password, &password_len, &customnumber, &customnumber_len) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(sms,ptrBtnSms,&sms_resource,-1,le_btnsms_name,le_btnsms);
	
	creds = btnCredsNew(userid,password);
	
	if (!creds)
	    RETURN_FALSE
	
	if (customnumber)
	    btnCredsSetCustomer(creds,customnumber);
	    
	btnSmsSetCreds(sms,creds);
		
	RETURN_TRUE
		
}

PHP_FUNCTION(btnsms_adddestination)
{
	ptrBtnSms sms;
	zval *sms_resource;
	char *dest;
	char *greet;
	int dest_size, greet_size;

	greet = 0;

	if (ZEND_NUM_ARGS() < 2 || ZEND_NUM_ARGS() > 3) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "rs|s", &sms_resource, &dest, &dest_size, &greet, &greet_size) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(sms,ptrBtnSms,&sms_resource,-1,le_btnsms_name,le_btnsms);
	
	if (greet) {
	    if (!btnSmsAddDestinationGreet(sms,dest,dest_size,greet,greet_size))
		RETURN_FALSE
	    else
		RETURN_TRUE
	} else {	    
	    if (!btnSmsAddDestination(sms,dest,dest_size))
		RETURN_FALSE
	    else
		RETURN_TRUE
	}
}

PHP_FUNCTION(btnsms_settext)
{
	ptrBtnSms sms;
	zval *sms_resource;
	char *text;
	int text_len;
	
	if (ZEND_NUM_ARGS() != 2) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "rs", &sms_resource, &text, &text_len) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(sms,ptrBtnSms,&sms_resource,-1,le_btnsms_name,le_btnsms);
	
	if (!btnSmsSetText(sms,text,text_len))
	    RETURN_FALSE
	else
	    RETURN_TRUE
}

PHP_FUNCTION(btnsms_settype)
{
	ptrBtnSms sms;
	zval *sms_resource;
	int type;
	
	if (ZEND_NUM_ARGS() != 2) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "rl", &sms_resource, &type) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(sms,ptrBtnSms,&sms_resource,-1,le_btnsms_name,le_btnsms);
	
	btnSmsSetType(sms,type);

	RETURN_TRUE	
}

PHP_FUNCTION(btnsms_settarif)
{
	ptrBtnSms sms;
	zval *sms_resource;
	int tarif;
	
	if (ZEND_NUM_ARGS() != 2) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "rl", &sms_resource, &tarif) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(sms,ptrBtnSms,&sms_resource,-1,le_btnsms_name,le_btnsms);
	
	btnSmsSetTarif(sms,tarif);

	RETURN_TRUE	
}

PHP_FUNCTION(btnsms_setdelivery)
{
	ptrBtnSms sms;
	zval *sms_resource;
	int day;
	int month;
	int year;
	int hour;
	int minute;
	
	hour = 0;
	minute = 0;
	
	if (ZEND_NUM_ARGS() < 4 || ZEND_NUM_ARGS() > 6) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "rlll|ll", &sms_resource, &day, &month, &year, &hour, &minute) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(sms,ptrBtnSms,&sms_resource,-1,le_btnsms_name,le_btnsms);
	
	btnSmsSetDelivery(sms,day,month,year,hour,minute);

	RETURN_TRUE		
}

PHP_FUNCTION(btnsms_setoriginator)
{
	ptrBtnSms sms;
	zval *sms_resource;
	char *orig;
	int orig_len;
	
	if (ZEND_NUM_ARGS() != 2) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "rs", &sms_resource, &orig, &orig_len) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(sms,ptrBtnSms,&sms_resource,-1,le_btnsms_name,le_btnsms);
	
	if (!btnSmsSetOriginator(sms,orig,orig_len))
	    RETURN_FALSE
	else
	    RETURN_TRUE
}

PHP_FUNCTION(btnsms_setgreetsubst)
{
	ptrBtnSms sms;
	zval *sms_resource;
	char *subst;
	int subst_len;
	
	if (ZEND_NUM_ARGS() != 2) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "rs", &sms_resource, &subst, &subst_len) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(sms,ptrBtnSms,&sms_resource,-1,le_btnsms_name,le_btnsms);
	
	if (!btnSmsSetGreetSubst(sms,subst,subst_len))
	    RETURN_FALSE
	else
	    RETURN_TRUE
}

PHP_FUNCTION(btnsms_send)
{
	ptrBtnSms sms;
	ptrBtnResult result;
	zval *sms_resource;
	zval *result_resource;
	zval *destinations;
	
	int result_id;
	
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "r", &sms_resource) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(sms,ptrBtnSms,&sms_resource,-1,le_btnsms_name,le_btnsms);
	
	result = btnSmsSend(sms);

	if (!result)
	    RETURN_NULL();

	MAKE_STD_ZVAL(result_resource);
	
	result_id = ZEND_REGISTER_RESOURCE(result_resource, result, le_btnresult);	

	RETURN_RESOURCE(result_id);
		
}

PHP_FUNCTION(btnsms_geterrorcode)
{
	ptrBtnResult result;
	zval *result_resource;
	int errorcode;
		
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "r", &result_resource) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(result,ptrBtnResult,&result_resource,-1,le_btnresult_name,le_btnresult);
	
	errorcode = btnResultGetErrorcode(result);
	
	RETURN_LONG(errorcode)	
}

PHP_FUNCTION(btnsms_geterrormsg)
{
	ptrBtnResult result;
	zval *result_resource;
	char *errormsg;
		
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "r", &result_resource) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(result,ptrBtnResult,&result_resource,-1,le_btnresult_name,le_btnresult);
	
	errormsg = btnResultGetErrorMsg(result);
	
	if (!errormsg)
	    RETURN_EMPTY_STRING()
	else
	    RETURN_STRING(errormsg,1)		
}

PHP_FUNCTION(btnsms_getaccountbalance)
{
	ptrBtnResult result;
	zval *result_resource;
	char *accountbalance;
		
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "r", &result_resource) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(result,ptrBtnResult,&result_resource,-1,le_btnresult_name,le_btnresult);
	
	accountbalance = btnResultGetAccountBalance(result);
	
	if (!accountbalance)
	    RETURN_EMPTY_STRING()
	else
	    RETURN_STRING(accountbalance,1)		
}

PHP_FUNCTION(btnsms_getstatusreportid)
{
	ptrBtnResult result;
	zval *result_resource;
	char *statusid;
		
	if (ZEND_NUM_ARGS() != 1) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "r", &result_resource) == FAILURE) {
	    return;
	}
	
	ZEND_FETCH_RESOURCE(result,ptrBtnResult,&result_resource,-1,le_btnresult_name,le_btnresult);
	
	statusid = btnResultGetStatusReportId(result);
	
	if (!statusid)
	    RETURN_EMPTY_STRING()
	else
	    RETURN_STRING(statusid,1)		
}

PHP_FUNCTION(btnsms_getuserstatus)
{
	ptrBtnCreds creds;
	ptrBtnUserstatus status;
	char *userid;
	char *pwd;
	int userid_len, pwd_len;

	char *f_errormsg;
	char *f_userid;
	char *f_accountbalance;
	
	if (ZEND_NUM_ARGS() != 2) WRONG_PARAM_COUNT;
	
	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_DC, "ss", &userid, &userid_len, &pwd, &pwd_len) == FAILURE) {
	    return;
	}
	
	creds = btnCredsNew(userid,pwd);	
	status = btnUserstatusRequest(creds);
	
	array_init(return_value);
	
	add_assoc_long(return_value,"errorcode",btnUserstatusGetErrorcode(status));
	f_errormsg = btnUserstatusGetErrorMsg(status);
	add_assoc_string(return_value,"errormsg",f_errormsg?f_errormsg:empty_string,1);
	
	if (btnUserstatusGetErrorcode(status) == 0) {
	    f_userid = btnUserstatusGetUserid(status);
	    add_assoc_string(return_value,"userid",f_userid?f_userid:empty_string,1);
	    add_assoc_bool(return_value,"active",btnUserstatusGetActive(status));
	    add_assoc_long(return_value,"type",btnUserstatusGetType(status));
	    f_accountbalance = btnUserstatusGetAccountBalance(status);
	    add_assoc_string(return_value,"accountbalance",f_accountbalance?f_accountbalance:empty_string,1);
	    add_assoc_long(return_value,"today",btnUserstatusGetToday(status));
	    add_assoc_long(return_value,"limit",btnUserstatusGetLimit(status));
	}
	
	btnCredsFree(creds);
	btnUserstatusFree(status);
	
	return;	
}

PHP_FUNCTION(btnsms_getdestinationerrors)
{
    RETURN_NULL()
}

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
